Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cube.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cube.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cube.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -24,6 +24,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1"
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" --no-dry-run --store-session session-fill-surface-cube.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cube.py >session-fill-surface-cube_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cube_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -37,6 +38,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo --no-dry-run --store-session session-fill-surface-cube.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cube.py >session-fill-surface-cube_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cube_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -50,6 +52,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cube1" 		--shape-type "cube" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "cube1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo --no-dry-run --store-session session-fill-surface-cube.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cube.py >session-fill-surface-cube_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cube_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cylinder.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cylinder.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-cylinder.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -24,6 +24,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1"
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" --no-dry-run --store-session session-fill-surface-cylinder.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cylinder.py >session-fill-surface-cylinder_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cylinder_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -37,6 +38,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo --no-dry-run --store-session session-fill-surface-cylinder.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cylinder.py >session-fill-surface-cylinder_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cylinder_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -50,6 +52,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "cylinder1" 		--shape-type "cylinder" 		--translation "10,10,0." 		--stretch "5.,5.,20." 	--select-shape-by-name "cylinder1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo --no-dry-run --store-session session-fill-surface-cylinder.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-cylinder.py >session-fill-surface-cylinder_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-cylinder_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-everywhere.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-everywhere.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-everywhere.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -24,6 +24,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "everywhere1" 		--shape-type "everywhere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "everywhere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1"
-], 5, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "everywhere1" 		--shape-type "everywhere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "everywhere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" --no-dry-run --store-session session-fill-surface-everywhere.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-everywhere.py >session-fill-surface-everywhere_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-everywhere_new.py], 5, [stdout], [stderr])
 #AT_CHECK([grep "20 out of 20 returned true from predicate" stdout], 0, [ignore], [ignore])
 #AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-micelle.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-micelle.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-micelle.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -25,6 +25,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/tensid.potentials .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1"
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" --no-dry-run --store-session session-fill-surface-micelle.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-micelle.py >session-fill-surface-micelle_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-micelle_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/tensid.data], 0, [ignore], [ignore])
 
@@ -39,6 +40,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/tensid.potentials .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" 	--undo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" 	--undo --no-dry-run --store-session session-fill-surface-micelle.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-micelle.py >session-fill-surface-micelle_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-micelle_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -53,6 +55,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/tensid.potentials .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" 	--undo 	--redo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	--parse-particle-parameters tensid.potentials 	-i $file 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" 	--undo 	--redo --no-dry-run --store-session session-fill-surface-micelle.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-micelle.py >session-fill-surface-micelle_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-micelle_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/tensid.data], 0, [ignore], [ignore])
 
Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-nowhere.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-nowhere.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-nowhere.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -24,6 +24,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "nowhere1" 		--shape-type "nowhere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "nowhere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1"
-], 5, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "nowhere1" 		--shape-type "nowhere" 		--translation "0,0,0" 		--stretch "20.,20.,20." 	--select-shape-by-name "nowhere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,1" --no-dry-run --store-session session-fill-surface-nowhere.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-nowhere.py >session-fill-surface-nowhere_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-nowhere_new.py], 5, [stdout], [stderr])
 #AT_CHECK([grep "20 out of 20 returned true from predicate" stdout], 0, [ignore], [ignore])
 #AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
Index: tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-sphere.at
===================================================================
--- tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-sphere.at	(revision d50b9151219b75020931486afa73b2b92312849b)
+++ tests/GuiChecks/Filling/FillSurface/testsuite-fill-surface-sphere.at	(revision 425516a7f03921844313b8d9804f147b3c796d9e)
@@ -24,6 +24,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1"
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" --no-dry-run --store-session session-fill-surface-sphere.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-sphere.py >session-fill-surface-sphere_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-sphere_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -37,6 +38,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo --no-dry-run --store-session session-fill-surface-sphere.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-sphere.py >session-fill-surface-sphere_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-sphere_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 
@@ -50,6 +52,7 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/FillSurface/pre/water.xyz water.xyz], 0)
 AT_CHECK([chmod u+w water.xyz], 0)
-AT_CHECK([../../molecuilder 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo
-], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --dry-run 	-i $file 	-l water.xyz 	--select-all-molecules 	--rotate-to-principal-axis-system "0,0,-1" 	--create-shape 		--shape-name "sphere1" 		--shape-type "sphere" 		--translation "10,10,10" 		--stretch "5.,5.,5." 	--select-shape-by-name "sphere1" 	--fill-surface 		--count 20 		--min-distance 3.1 		--Alignment-Axis "0,0,-1" 	--undo 	--redo --no-dry-run --store-session session-fill-surface-sphere.py --session-type python], 0, [stdout], [stderr])
+AT_CHECK([grep -v "Command.*DryRun" session-fill-surface-sphere.py >session-fill-surface-sphere_new.py], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilderguitest session-fill-surface-sphere_new.py], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/FillSurface/post/$file], 0, [ignore], [ignore])
 