Index: src/UIElements/TextUI/Query/KeyValuePairTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/KeyValuePairTextQuery.cpp	(revision 0435989b70a2b793f218705f1cf498471af2bdd2)
+++ src/UIElements/TextUI/Query/KeyValuePairTextQuery.cpp	(revision 0435989b70a2b793f218705f1cf498471af2bdd2)
@@ -0,0 +1,57 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2015 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * KeyValuePairTextQuery.cpp
+ *
+ *  Created on: May 16, 2015
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+
+#include "TextUI/Query/TextQuery.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+#include "Parameters/Specifics/KeyValuePair.hpp"
+
+TextDialog::KeyValuePairTextQuery::KeyValuePairTextQuery(Parameter<KeyValuePair> &_param, const std::string &_title, const std::string &_description) :
+    Dialog::TQuery<KeyValuePair>(_param, _title,_description)
+{}
+
+TextDialog::KeyValuePairTextQuery::~KeyValuePairTextQuery() {}
+
+bool TextDialog::KeyValuePairTextQuery::handle() {
+  std::cout << getDescription() << ": ";
+  getline(std::cin,temp);
+  return true;
+}
+
Index: src/UIElements/TextUI/Query/KeyValuePairsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/KeyValuePairsTextQuery.cpp	(revision 0435989b70a2b793f218705f1cf498471af2bdd2)
+++ src/UIElements/TextUI/Query/KeyValuePairsTextQuery.cpp	(revision 0435989b70a2b793f218705f1cf498471af2bdd2)
@@ -0,0 +1,69 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2015 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * KeyValuePairsTextQuery.cpp
+ *
+ *  Created on: May 16, 2015
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+
+#include "TextUI/Query/TextQuery.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+#include "Parameters/Specifics/KeyValuePair.hpp"
+
+TextDialog::KeyValuePairsTextQuery::KeyValuePairsTextQuery(Parameter<std::vector<KeyValuePair> > &_param, const std::string &_title, const std::string &_description) :
+    Dialog::TQuery<std::vector<KeyValuePair> >(_param, _title,_description)
+{}
+
+TextDialog::KeyValuePairsTextQuery::~KeyValuePairsTextQuery() {}
+
+bool TextDialog::KeyValuePairsTextQuery::handle() {
+  std::cout << getDescription() << ": ";
+  std::string temp_element;
+  getline(std::cin,temp_element);
+  // dissect by " "
+  std::string::iterator olditer = temp_element.begin();
+  for(std::string::iterator iter = temp_element.begin(); iter != temp_element.end(); ++iter) {
+    if (*iter == ' ') {
+      temp.push_back(std::string(iter, olditer));
+      olditer = iter;
+    }
+  }
+  if (olditer != temp_element.begin())  // insert last part also
+    temp.push_back(std::string(olditer, temp_element.end()));
+
+  return true;
+}
+
Index: src/UIElements/TextUI/Query/TextQuery.hpp
===================================================================
--- src/UIElements/TextUI/Query/TextQuery.hpp	(revision 3a4be0dfdbe8f8c566c8fc42b0e9a6c0a2bf76b6)
+++ src/UIElements/TextUI/Query/TextQuery.hpp	(revision 0435989b70a2b793f218705f1cf498471af2bdd2)
@@ -108,4 +108,18 @@
 };
 
+class TextDialog::KeyValuePairTextQuery : public Dialog::TQuery<KeyValuePair> {
+public:
+  KeyValuePairTextQuery(Parameter<KeyValuePair> &, const std::string &_title, const std::string &_description = NULL);
+  virtual ~KeyValuePairTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::KeyValuePairsTextQuery : public Dialog::TQuery<std::vector<KeyValuePair> > {
+public:
+  KeyValuePairsTextQuery(Parameter<std::vector<KeyValuePair> > &, const std::string &_title, const std::string &_description = NULL);
+  virtual ~KeyValuePairsTextQuery();
+  virtual bool handle();
+};
+
 class TextDialog::MoleculeTextQuery : public Dialog::TQuery<const molecule *> {
 public: